$TronBrickLifeTime = 5 * 1000; //5 seconds.
datablock fxDTSBrickData(TronBrickData)
{
	brickFile = "./2xCube.blb";
	category = "Baseplates";
	subCategory = "Cube";
	uiName = "";
};
function TronVehicle(%vehicle,%s)
{
	if(isObject(%vehicle) == false)
		return;
	if(isObject(%client = %vehicle.getMountedObject(0).client) == false)
		return;
	if(%vehicle.tronToggle == true && %s == false)
	{
		%vehicle.tronToggle = false;
		cancel(%vehicle.tronLoop);
		%vehicle.tronLoop = ""; 
	}
	else
	{
		%vehicle.tronToggle = true;
		%pos = getObjectBackPosition(%vehicle);
		%pos = snapBrick(%pos,2);
		%pos = getWord(%pos,0) SPC getWord(%pos,1) SPC getWord(%pos,2) + 1;
		if($Tron::Used[%pos] || isTronMoving(%vehicle) == false)
		{
			%vehicle.tronLoop = schedule(50,0,TronVehicle,%vehicle,true);
			return;
		}
		%brick = new fxDTSBrick()
		{
			position = %pos;
			datablock = TronBrickData;
			client = %client;
			isPlanted = 1;
			colorID = %client.player.currSprayCan;
		};
		%client.brickGroup.add(%brick);
		%brick.setTrusted(true);
		%brick.plant();
		$Tron::Used[%pos] = true;
		schedule($TronBrickLifeTime,0,eval,"$Tron::Used[\"" @ %pos @ "\"] = false;");
		%brick.schedule($TronBrickLifeTime,delete);
		%vehicle.tronLoop = schedule(100,0,TronVehicle,%vehicle,true);
	}
}
function isTronMoving(%tron)
{
	%vel = %tron.getVelocity();
	%x = getWord(%vel,0);
	%y = getWOrd(%vel,1);
	%z = getWord(%vel,2);
	%e = %x + %y + %z;
	%e = mAbs(%e);
	if(%e < 9)
		return false;
	return true;
}
function snapBrick(%pos,%grid)
{
	%grid = %grid / 2;
	%x = getWord(%pos,0);
	%y = getWord(%pos,1);
	%z = getWord(%pos,2);
	%x = mFloatLength((%x * %grid) / %grid,0);
	%y = mFloatLength((%y * %grid) / %grid,0);
	%z = mFloatLength((%z * %grid) / %grid,0);
	%pos = %x SPC %y SPC %z;
	return %pos;
}
//Thanks Zack0Wack0 for this
function getObjectBackPosition(%obj) {
	%pi = 3.14159;
	%box = %obj.getWorldBox();
	%max = getWords(%box, 3, 6);
	%min = getWords(%box, 0, 2);
	%size = vectorSub(%max, %min);
	%sizeX = getWord(%size, 0);
	%sizeY = getWord(%size, 1);
	%sizeZ = getWord(%size, 2);
	%forward = %obj.getForwardVector();
	%scaleX = getWord(%forward, 0) * 0.5;
	%scaleY = getWord(%forward, 1) * 0.5;
	%scaleZ = getWord(%forward, 2) * 0.5;
	
	return vectorSub(getWords(%obj.getTransform(), 0, 2), %sizeX * %scaleX SPC %sizeY * %scaleY SPC %sizeZ * %scaleZ);
}
if(isPackage(Tronpackage))
	deactivatepackage(tronpackage);
package TronPackage
{
	function Armor::onMount(%this,%player,%obj,%a,%b,%c,%d,%e,%f)
	{
		Parent::onMount(%this,%player,%obj,%a,%b,%c,%d,%e,%f);
		if(isObject(%obj.spawnBrick) && isObject(%player.client) && %obj.getDatablock().rideable)
		{
			%brick = %obj.spawnBrick;
			%vehicle = %obj;
			if(%vehicle.getDatablock().getName() $= "TronLightBikeVehicle")
				%player.hideNode("ALL");
		}
	}
	function Armor::onUnMount(%this,%player,%obj,%a,%b,%c,%d,%e,%f)
	{
		%p = Parent::onUnMount(%this,%player,%obj,%a,%b,%c,%d,%e,%f);
		if(isObject(%obj.spawnBrick) && isObject(%player.client) && %obj.getDatablock().rideable)
		{
			%brick = %obj.spawnBrick;
			if(%obj.getDatablock().getName() $= "TronLightBikeVehicle")
			{
				%player.unHideNode("ALL");
				%player.client.applyBodyParts();
				%player.client.applyBodyColors();
			}
			return %p;
		}
		else
		{
			if(!isObject(%obj))
				return %p; //I was having some weird console errors.
			if(%obj.getDatablock().getName() $= "TronLightBikeVehicle")
			{
				if(%obj.rider)
					%obj.schedule(1,mountObject,%player,0);
			}
			else
				return %p;
		}
	}
	function serverCmdLight(%client)
	{
		if(isObject(%mnt = %client.player.getObjectMount()) == true)
		{
			if(%mnt.getDatablock().getName() $= "TronLightBikeVehicle")
			{
				TronVehicle(%mnt,false);
				return;
			}
		}
		parent::serverCmdLight(%client);
	}
};
activatePackage(TronPackage);
